CSIT-1419 Convert vpp-virl job to vpp-device
[csit.git] / resources / libraries / bash / entry / per_patch_device.sh
diff --git a/resources/libraries/bash/entry/per_patch_device.sh b/resources/libraries/bash/entry/per_patch_device.sh
new file mode 100644 (file)
index 0000000..3f52bcb
--- /dev/null
@@ -0,0 +1,57 @@
+#!/usr/bin/env bash
+
+# Copyright (c) 2019 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+set -exuo pipefail
+
+# This entry script does not change CSIT branch,
+# use "with_oper_for_vpp.sh" wrapper for that.
+#
+# Assumptions:
+# + There is a directory holding VPP repo with patch under test checked out.
+# + It contains csit subdirectory with CSIT code to use (this script is there).
+# + Everything needed to build VPP is already installed locally.
+# Consequences:
+# + The following directories (relative to VPP repo) are (re)created:
+# ++ csit_current, build_current, archive, csit/archive, csit_download_dir.
+
+# TODO: Implement some kind of VPP build caching.
+
+# "set -eu" handles failures from the following two lines.
+BASH_ENTRY_DIR="$(dirname $(readlink -e "${BASH_SOURCE[0]}"))"
+BASH_FUNCTION_DIR="$(readlink -e "${BASH_ENTRY_DIR}/../function")"
+source "${BASH_FUNCTION_DIR}/common.sh" || {
+    echo "Source failed." >&2
+    exit 1
+}
+source "${BASH_FUNCTION_DIR}/per_patch.sh" || die "Source failed."
+common_dirs || die
+set_perpatch_vpp_dir || die
+build_vpp_ubuntu_amd64 "CURRENT" || die
+set_aside_commit_build_artifacts || die
+initialize_csit_dirs || die
+get_test_code "${1-}" || die
+get_test_tag_string || die
+set_perpatch_dut || die
+select_topology || die
+select_build "build_current" || die
+check_download_dir || die
+activate_virtualenv "${VPP_DIR}" || die
+activate_docker_topology || die
+select_vpp_device_tags || die
+compose_pybot_arguments || die
+run_pybot || die
+copy_archives || die
+archive_parse_test_results "csit_current" || die
+die_on_pybot_error || die